From 8d611c86bde7f8dcd1404974c5fb26ab9cec1fc7 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Fri, 21 Aug 2020 16:04:35 +0800
Subject: [PATCH] Add tree build shell script

---
 3rdparty/stunnel/build.sh |  111 +++++++++++++++++++++++++++
 3rdparty/tree/build.sh    |   95 +++++++++++++++++++++++
 2 files changed, 206 insertions(+), 0 deletions(-)

diff --git a/3rdparty/stunnel/build.sh b/3rdparty/stunnel/build.sh
new file mode 100755
index 0000000..903cab9
--- /dev/null
+++ b/3rdparty/stunnel/build.sh
@@ -0,0 +1,111 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile stunnel for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2018.08.16
+#+--------------------------------------------------------------------------------------------
+
+PREFIX_PATH=`pwd`/../install/
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export CXX=${CROSSTOOL}g++
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+
+function compile_stunnel()
+{
+    SRC_NAME=stunnel-5.55
+    PACK_SUFIX=tar.gz
+
+    if [ -f ${PREFIX_PATH}/bin/stunnel ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        #wget http://www.usenix.org.uk/mirrors/stunnel/${SRC_NAME}.${PACK_SUFIX}
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    # fix can't load library 'libssp.so.0' bug
+    sed -i -e "s/fstack-protector/pthread/g" configure
+
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} --enable-static --disable-shared --disable-largefile --disable-ipv6 \
+       --disable-systemd --disable-libwrap --with-ssl=${PREFIX_PATH}  CFLAGS="-DHAVE_GETNAMEINFO -UHAVE_DAEMON " 
+    check_result "ERROR: configure ${SRC_NAME} failure"
+
+    sed -i -e "s|^LDFLAGS =.*|LDFLAGS =-static|g" src/Makefile
+    sed -i -e "s|^#define HAVE_DAEMON.*|#undef HAVE_DAEMON|g" src/config.h
+    make
+    check_result "ERROR: compile ${SRC_NAME} failure"
+
+    ${STRIP} src/stunnel
+    cp src/stunnel ${PREFIX_PATH}/bin
+
+    cd -
+}
+
+
+if [ ! -f ${PREFIX_PATH}/lib/libcrypto.so ] ; then
+    cd ../openssl
+    ./build.sh
+    cd -
+fi
+
+
+export_cross
+
+compile_stunnel
+
+
diff --git a/3rdparty/tree/build.sh b/3rdparty/tree/build.sh
new file mode 100755
index 0000000..a6fae53
--- /dev/null
+++ b/3rdparty/tree/build.sh
@@ -0,0 +1,95 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile tree for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PREFIX_PATH=`pwd`/../install/bin
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+function compile_tree()
+{
+    SRC_NAME=tree-1.8.0
+    PACK_SUFIX=tgz
+
+    if [ -f ${PREFIX_PATH}/tree ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        #wget ftp://ftp.astron.com/pub/file/${SRC_NAME}.${PACK_SUFIX}
+        wget ${LYFTP_SRC}/tree-1.8.0.tgz
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    sed -i -e "s|^CC=.*|CC=${CROSSTOOL}gcc|g" Makefile
+
+    make 
+    check_result "ERROR: compile ${SRC_NAME} failure"
+
+    ${STRIP} tree
+    cp tree ${PREFIX_PATH} 
+    cp tree ..
+
+    cd -
+}
+
+
+export_cross
+
+compile_tree
+
+

--
Gitblit v1.9.1